## yadm 1.03

=== Makefile ===
all: yadm.md contrib

yadm.md: yadm.1
	@groff -man -Tascii ./yadm.1 | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md

contrib:
	@echo "CONTRIBUTORS\n" > CONTRIBUTORS
	@git shortlog -ns | cut -f2 >> CONTRIBUTORS

pdf:
	@groff -man -Tps ./yadm.1 > yadm.ps
	@open yadm.ps
	@sleep 1
	@rm yadm.ps

man:
	groff -man -Tascii ./yadm.1 | less

wide:
	man ./yadm.1

=== debian/changelog ===
yadm (1.03-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 18 Jan 2016 19:34:20 +0800

yadm (1.02-2) unstable; urgency=low

  * fix manpage-has-errors-from-man warning.

 -- Yao-Po Wang <blue119@gmail.com>  Sat, 07 Nov 2015 13:08:12 +0800

yadm (1.02-1) unstable; urgency=low

  * Initial release. Closes: #800360

 -- Yao-Po Wang <blue119@gmail.com>  Tue, 06 Oct 2015 20:40:25 +0800

=== debian/control ===
Source: yadm
Priority: optional
Section: utils
Maintainer: Yao-Po Wang <blue119@gmail.com>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper (>=9)
Standards-Version: 3.9.6
Homepage: https://github.com/TheLocehiliosan/yadm
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/yadm.git
Vcs-Git: git://anonscm.debian.org/collab-maint/yadm.git

Package: yadm
Architecture: all
Depends: ${misc:Depends}
Description: Yet Another Dotfiles Manager
 yadm is a dotfile management tool with 3 main features: Manages files across
 systems using a single Git repository. Provides a way to use alternate files on
 a specific OS or host. Supplies a method of encrypting confidential data so it
 can safely be stored in your repository.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_build:

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_install:
	install -D yadm debian/yadm/usr/bin/yadm

## yadm 1.04

=== Makefile ===
--- 
+++ 
@@ -13,6 +13,27 @@
 	@sleep 1
 	@rm yadm.ps
 
+.PHONY: test
+test: bats shellcheck
+
+.PHONY: bats
+bats:
+	@echo Running all bats tests
+	@bats test
+
+.PHONY: shellcheck
+shellcheck:
+	@echo Running shellcheck
+	@shellcheck --version || true
+	@shellcheck -s bash yadm test/*.bash
+	@for bats_file in test/*bats; do \
+		sed 's/^@test.*{/function test() {/' "$$bats_file" > "$$bats_file .bash"; \
+		shellcheck -s bash "$$bats_file .bash"; \
+		test_result="$$?"; \
+		rm -f "$$bats_file .bash"; \
+		[ "$$test_result" -ne 0 ] && exit 1; \
+	done; true
+
 man:
 	groff -man -Tascii ./yadm.1 | less

=== debian/changelog ===
yadm (1.04-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 27 Apr 2016 20:19:33 +0800

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Yao-Po Wang <blue119@gmail.com>
 Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Build-Depends: debhelper (>=9)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/TheLocehiliosan/yadm
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/yadm.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/yadm.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/yadm.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/yadm.git
 
 Package: yadm
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -11,3 +11,6 @@
 
 override_dh_install:
 	install -D yadm debian/yadm/usr/bin/yadm
+	
+override_dh_auto_test:
+	# The test needs home directory, so it is disabled.

## yadm 1.05

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 .PHONY: bats
 bats:
 	@echo Running all bats tests
-	@bats test
+	@GPG_AGENT_INFO= bats test
 
 .PHONY: shellcheck
 shellcheck:

## yadm 1.06

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 contrib:
 	@echo "CONTRIBUTORS\n" > CONTRIBUTORS
-	@git shortlog -ns | cut -f2 >> CONTRIBUTORS
+	@git shortlog -ns master gh-pages dev dev-pages | cut -f2 >> CONTRIBUTORS
 
 pdf:
 	@groff -man -Tps ./yadm.1 > yadm.ps
@@ -26,11 +26,12 @@
 	@echo Running shellcheck
 	@shellcheck --version || true
 	@shellcheck -s bash yadm test/*.bash
-	@for bats_file in test/*bats; do \
-		sed 's/^@test.*{/function test() {/' "$$bats_file" > "$$bats_file .bash"; \
-		shellcheck -s bash "$$bats_file .bash"; \
+	@cd test; \
+	for bats_file in *bats; do \
+		sed 's/^@test.*{/function test() {/' "$$bats_file" > "/tmp/$$bats_file.bash"; \
+		shellcheck -s bash "/tmp/$$bats_file.bash"; \
 		test_result="$$?"; \
-		rm -f "$$bats_file .bash"; \
+		rm -f "/tmp/$$bats_file.bash"; \
 		[ "$$test_result" -ne 0 ] && exit 1; \
 	done; true

=== debian/changelog ===
yadm (1.06-1+deb9u1) stretch; urgency=high

  * Backport for CVE-2017-11353.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 29 Aug 2017 18:55:37 +0800

yadm (1.06-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 22 Jan 2017 20:34:20 +0800

yadm (1.05-1) unstable; urgency=medium

  * New upstream release.
  * Bump compat level to 10.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 19 Sep 2016 19:09:21 +0800

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Section: utils
 Maintainer: Yao-Po Wang <blue119@gmail.com>
 Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
-Build-Depends: debhelper (>=9)
+Build-Depends: debhelper (>= 10)
 Standards-Version: 3.9.8
 Homepage: https://github.com/TheLocehiliosan/yadm
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/yadm.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/yadm.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/yadm.git
 
 Package: yadm

## yadm 1.11.0

=== Makefile ===
--- 
+++ 
@@ -16,6 +16,10 @@
 .PHONY: test
 test: bats shellcheck
 
+.PHONY: parallel
+parallel:
+	ls test/*bats | time parallel -q -P0 -- docker run --rm -v "$$PWD:/yadm:ro" yadm/testbed bash -c 'bats {}'
+
 .PHONY: bats
 bats:
 	@echo Running all bats tests
@@ -25,7 +29,7 @@
 shellcheck:
 	@echo Running shellcheck
 	@shellcheck --version || true
-	@shellcheck -s bash yadm test/*.bash
+	@shellcheck -s bash yadm bootstrap test/*.bash completion/yadm.bash_completion
 	@cd test; \
 	for bats_file in *bats; do \
 		sed 's/^@test.*{/function test() {/' "$$bats_file" > "/tmp/$$bats_file.bash"; \

=== debian/changelog ===
yadm (1.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.0.0.
    * Use https in Format in d/copyright.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 17 Jul 2017 12:37:06 +0800

yadm (1.10.0-1) unstable; urgency=medium

  * Merge back to unstable.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 17 Jun 2017 22:56:14 +0800

yadm (1.10.0-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 20 May 2017 10:54:52 +0800

yadm (1.09-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 07 May 2017 18:11:54 +0800

yadm (1.08-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 05 Apr 2017 10:28:13 +0800

yadm (1.07-1~exp2) experimental; urgency=medium

  * Add Multi-Arch: foreign.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 26 Mar 2017 14:12:21 +0800

yadm (1.07-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 13 Feb 2017 18:43:39 +0800

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,14 @@
 Maintainer: Yao-Po Wang <blue119@gmail.com>
 Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Build-Depends: debhelper (>= 10)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://github.com/TheLocehiliosan/yadm
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/yadm.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/yadm.git
 
 Package: yadm
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Yet Another Dotfiles Manager
  yadm is a dotfile management tool with 3 main features: Manages files across

## yadm 1.12.0

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,15 @@
+.PHONY: all
 all: yadm.md contrib
 
 yadm.md: yadm.1
 	@groff -man -Tascii ./yadm.1 | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md
 
+.PHONY: contrib
 contrib:
 	@echo "CONTRIBUTORS\n" > CONTRIBUTORS
 	@git shortlog -ns master gh-pages dev dev-pages | cut -f2 >> CONTRIBUTORS
 
+.PHONY: pdf
 pdf:
 	@groff -man -Tps ./yadm.1 > yadm.ps
 	@open yadm.ps
@@ -39,8 +42,19 @@
 		[ "$$test_result" -ne 0 ] && exit 1; \
 	done; true
 
+.PHONY: testhost
+testhost:
+	@target=HEAD
+	@rm -rf /tmp/testhost
+	@git show $(target):yadm > /tmp/testhost
+	@chmod a+x /tmp/testhost
+	@echo Starting testhost target=\"$$target\"
+	@docker run -w /root --hostname testhost --rm -it -v "/tmp/testhost:/bin/yadm:ro" yadm/testbed:latest bash
+
+.PHONY: man
 man:
 	groff -man -Tascii ./yadm.1 | less
 
+.PHONY: wide
 wide:
 	man ./yadm.1

=== debian/changelog ===
yadm (1.12.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.2.0.
  * Bump compat to 11.
  * Add git to Depends.
  * Change Vcs-* fields to salsa.debian.org.
  * Install bash/zsh auto completion.
  * Add debian/upstream/metadata.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 09 Aug 2018 15:45:50 +0800

yadm (1.12.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.1.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 28 Oct 2017 12:21:58 +0800

yadm (1.11.1-1) unstable; urgency=high

  * New upstream release.
    * Fix CVE-2017-11353 (Closes: #868300).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 28 Aug 2017 18:33:06 +0800

=== debian/control ===
Source: yadm
Priority: optional
Section: utils
Maintainer: Yao-Po Wang <blue119@gmail.com>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper (>= 11),
               bats,
               expect,
               shellcheck,
Standards-Version: 4.2.0
Homepage: https://github.com/TheLocehiliosan/yadm
Vcs-Browser: https://salsa.debian.org/debian/yadm
Vcs-Git: https://salsa.debian.org/debian/yadm.git

Package: yadm
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         git,
Description: Yet Another Dotfiles Manager
 yadm is a dotfile management tool with 3 main features: Manages files across
 systems using a single Git repository. Provides a way to use alternate files on
 a specific OS or host. Supplies a method of encrypting confidential data so it
 can safely be stored in your repository.

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,8 @@
 	dh_installchangelogs CHANGES
 
 override_dh_install:
+	dh_install
 	install -D yadm debian/yadm/usr/bin/yadm
-	
+
 override_dh_auto_test:
 	# The test needs home directory, so it is disabled.

## yadm 2.3.0

=== Makefile ===
PYTESTS = $(wildcard test/test_*.py)

.PHONY: all
all:
	@$(MAKE) usage | less

# Display usage for all make targets
.PHONY: usage
usage:
	@echo
	@echo 'make TARGET [option=value, ...]'
	@echo
	@echo 'TESTING'
	@echo
	@echo '  make test [testargs=ARGS]'
	@echo '    - Run all tests. "testargs" can specify a single string of arguments'
	@echo '      for py.test.'
	@echo
	@echo '  make <testfile>.py [testargs=ARGS]'
	@echo '    - Run tests from a specific test file. "testargs" can specify a'
	@echo '      single string of arguments for py.test.'
	@echo
	@echo '  make testhost [version=VERSION]'
	@echo '    - Create an ephemeral container for doing adhoc yadm testing. The'
	@echo '      HEAD revision of yadm will be used unless "version" is'
	@echo '      specified. "version" can be set to any commit, branch, tag, etc.'
	@echo '      The targeted "version" will be retrieved from the repo, and'
	@echo '      linked into the container as a local volume.'
	@echo
	@echo '  make scripthost [version=VERSION]'
	@echo '    - Create an ephemeral container for demonstrating a bug. After'
	@echo '      exiting the shell, a log of the commands used to illustrate the'
	@echo '      problem will be written to the file "script.txt". This file can'
	@echo '      be useful to developers to make a repeatable test for the'
	@echo '      problem.'
	@echo
	@echo 'LINTING'
	@echo
	@echo '  make testenv'
	@echo '    - Create a python virtual environment with the same dependencies'
	@echo "      used by yadm's testbed environment. Creating and activating"
	@echo '      this environment might be useful if your editor does real time'
	@echo '      linting of python files. After creating the virtual environment,'
	@echo '      you can activate it by typing:'
	@echo
	@echo '          source testenv/bin/activate'
	@echo
	@echo 'MANPAGES'
	@echo
	@echo '  make man'
	@echo '    - View yadm.1 as a standard man page.'
	@echo
	@echo '  make man-wide'
	@echo '    - View yadm.1 as a man page, using all columns of your display.'
	@echo
	@echo '  make man-ps'
	@echo '    - Create a postscript version of the man page.'
	@echo
	@echo 'FILE GENERATION'
	@echo
	@echo '  make yadm.md'
	@echo '    - Generate the markdown version of the man page (for viewing on'
	@echo '      the web).'
	@echo
	@echo '  make contrib'
	@echo '    - Generate the CONTRIBUTORS file, from the repo history.'
	@echo
	@echo 'INSTALLATION'
	@echo
	@echo '  make install PREFIX=<prefix>'
	@echo '    - Install yadm, manpage, etc. to <prefix>'
	@echo
	@echo 'UTILITIES'
	@echo
	@echo '  make sync-clock'
	@echo '    - Reset the hardware clock for the docker hypervisor host. This'
	@echo '      can be useful for docker engine hosts which are not'
	@echo '      Linux-based.'
	@echo

# Make it possible to run make specifying a py.test test file
.PHONY: $(PYTESTS)
$(PYTESTS):
	@$(MAKE) test testargs="-k $@ $(testargs)"
%.py:
	@$(MAKE) test testargs="-k $@ $(testargs)"

# Run all tests with additional testargs
.PHONY: test
test:
	@if [ -f /.yadmtestbed ]; then \
		cd /yadm && \
		py.test -v $(testargs); \
	else \
		if command -v "docker-compose" &> /dev/null; then \
			docker-compose run --rm testbed make test testargs="$(testargs)"; \
		else \
			echo "Sorry, this make test requires docker-compose to be installed."; \
			false; \
		fi \
	fi

.PHONY: testhost
testhost: require-docker
	@version=HEAD
	@rm -rf /tmp/testhost
	@git show $(version):yadm > /tmp/testhost
	@chmod a+x /tmp/testhost
	@echo Starting testhost version=\"$$version\"
	@docker run \
		-w /root \
		--hostname testhost \
		--rm -it \
		-v "/tmp/testhost:/bin/yadm:ro" \
		yadm/testbed:2019-12-02 \
		bash -l

.PHONY: scripthost
scripthost: require-docker
	@version=HEAD
	@rm -rf /tmp/testhost
	@git show $(version):yadm > /tmp/testhost
	@chmod a+x /tmp/testhost
	@echo Starting scripthost version=\"$$version\" \(recording script\)
	@printf '' > script.gz
	@docker run \
		-w /root \
		--hostname scripthost \
		--rm -it \
		-v "$$PWD/script.gz:/script.gz:rw" \
		-v "/tmp/testhost:/bin/yadm:ro" \
		yadm/testbed:2019-12-02 \
		bash -c "script /tmp/script -q -c 'bash -l'; gzip < /tmp/script > /script.gz"
	@echo
	@echo "Script saved to $$PWD/script.gz"


.PHONY: testenv
testenv:
	@echo 'Creating a local virtual environment in "testenv/"'
	@echo
	virtualenv --python=python3 testenv
	testenv/bin/pip3 install --upgrade pip setuptools
	testenv/bin/pip3 install --upgrade \
		flake8==3.7.8 \
		pylint==2.4.1 \
		pytest==5.1.3 \
		yamllint==1.17.0 \
	;
	@echo
	@echo 'To activate this test environment type:'
	@echo '  source testenv/bin/activate'

.PHONY: man
man:
	@groff -man -Tascii ./yadm.1 | less

.PHONY: man-wide
man-wide:
	@man ./yadm.1

.PHONY: man-ps
man-ps:
	@groff -man -Tps ./yadm.1 > yadm.ps

yadm.md: yadm.1
	@groff -man -Tascii ./yadm.1 | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md

.PHONY: contrib
contrib:
	@echo "CONTRIBUTORS\n" > CONTRIBUTORS
	@git shortlog -ns master gh-pages develop dev-pages | cut -f2 >> CONTRIBUTORS

.PHONY: install
install:
	@[ -n "$(PREFIX)" ] || { echo "PREFIX is not set"; exit 1; }
	@{\
		set -e                                               ;\
		bin="$(PREFIX)/bin"                                  ;\
		doc="$(PREFIX)/share/doc/yadm"                       ;\
		man="$(PREFIX)/share/man/man1"                       ;\
		install -d "$$bin" "$$doc" "$$man"                   ;\
		install -m 0755 yadm "$$bin"                         ;\
		install -m 0644 yadm.1 "$$man"                       ;\
		install -m 0644 CHANGES CONTRIBUTORS LICENSE "$$doc" ;\
		cp -r contrib "$$doc"                                ;\
	}

.PHONY: sync-clock
sync-clock:
	docker run --rm --privileged alpine hwclock -s

.PHONY: require-docker
require-docker:
	@if ! command -v "docker" &> /dev/null; then \
		echo "Sorry, this make target requires docker to be installed."; \
		false; \
	fi

=== debian/changelog ===
yadm (2.3.0-2) unstable; urgency=medium

  [ Angel Abad ]
  * Add debian/NEWS documenting the upgrade from 1.x versions.
  * Add myself to Uploaders and copyright.

  [ Russ Allbery ]
  * Upload to Debian with new maintainers.
  * Add myself to uploaders.
  * Run wrap-and-sort -ast.
  * Update standards version to 4.5.0 (no changes required).

 -- Russ Allbery <rra@debian.org>  Tue, 25 Feb 2020 09:33:17 -0800

yadm (2.3.0-1) unstable; urgency=medium

  * Local package for eyrie.org repository.
  * Update to new upstream version 2.3.0.
  * Update build commands to use the upstream make install target but
    remove some files that are installed by the packaging in other ways.
  * Remove build dependencies for the tests since they require Docker and
    thus are disabled.
  * Update to debhelper compatibility level V12.
    - Depend on debhelper-compat instead of using debian/compat.
  * Update to standards version 4.4.1.
    - Add Rules-Requires-Root: no.

 -- Russ Allbery <rra@debian.org>  Fri, 17 Jan 2020 11:51:37 -0800

=== debian/control ===
Source: yadm
Priority: optional
Section: utils
Maintainer: Yao-Po Wang <blue119@gmail.com>
Uploaders:
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
 Angel Abad <angel@debian.org>,
 Russ Allbery <rra@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/TheLocehiliosan/yadm
Vcs-Browser: https://salsa.debian.org/debian/yadm
Vcs-Git: https://salsa.debian.org/debian/yadm.git

Package: yadm
Architecture: all
Multi-Arch: foreign
Depends:
 git,
 ${misc:Depends},
Description: Yet Another Dotfiles Manager
 yadm is a dotfile management tool with 3 main features: Manages files across
 systems using a single Git repository. Provides a way to use alternate files on
 a specific OS or host. Supplies a method of encrypting confidential data so it
 can safely be stored in your repository.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PREFIX = debian/yadm/usr

%:
	dh $@

override_dh_auto_build:

# Remove some files installed by upstream that are installed by the
# packaging logic in different ways.
override_dh_auto_install:
	dh_auto_install
	rm debian/yadm/usr/share/doc/yadm/CHANGES
	rm debian/yadm/usr/share/doc/yadm/LICENSE

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

# The test requires Docker, so it is disabled.
override_dh_auto_test:

=== debian/watch ===
# You must remove unused comment lines for the released package.
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/$1\.tar\.gz/ \
       https://github.com/TheLocehiliosan/yadm/tags .*/v?(\d\S*)\.tar\.gz

## yadm 2.5.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 PYTESTS = $(wildcard test/test_*.py)
+IMAGE = yadm/testbed:2020-07-08
 
 .PHONY: all
 all:
@@ -112,7 +113,7 @@
 		--hostname testhost \
 		--rm -it \
 		-v "/tmp/testhost:/bin/yadm:ro" \
-		yadm/testbed:2019-12-02 \
+		$(IMAGE) \
 		bash -l
 
 .PHONY: scripthost
@@ -129,7 +130,7 @@
 		--rm -it \
 		-v "$$PWD/script.gz:/script.gz:rw" \
 		-v "/tmp/testhost:/bin/yadm:ro" \
-		yadm/testbed:2019-12-02 \
+		$(IMAGE) \
 		bash -c "script /tmp/script -q -c 'bash -l'; gzip < /tmp/script > /script.gz"
 	@echo
 	@echo "Script saved to $$PWD/script.gz"
@@ -139,7 +140,7 @@
 testenv:
 	@echo 'Creating a local virtual environment in "testenv/"'
 	@echo
-	virtualenv --python=python3 testenv
+	python3 -m venv --clear testenv
 	testenv/bin/pip3 install --upgrade pip setuptools
 	testenv/bin/pip3 install --upgrade \
 		flake8==3.7.8 \
@@ -169,7 +170,11 @@
 .PHONY: contrib
 contrib:
 	@echo "CONTRIBUTORS\n" > CONTRIBUTORS
-	@git shortlog -ns master gh-pages develop dev-pages | cut -f2 >> CONTRIBUTORS
+	@IFS=$$'\n'; for author in $$(git shortlog -ns master gh-pages develop dev-pages | cut -f2); do \
+		git log master gh-pages develop dev-pages \
+			--author="$$author" --format=tformat: --numstat | \
+			awk "{sum += \$$1 + \$$2} END {print sum \"\t\" \"$$author\"}"; \
+	done | sort -nr | cut -f2 >> CONTRIBUTORS
 
 .PHONY: install
 install:

=== debian/changelog ===
yadm (2.5.0-2) unstable; urgency=medium

  * Source only upload

 -- Angel Abad <angel@debian.org>  Thu, 20 Aug 2020 09:17:04 +0200

yadm (2.5.0-1) unstable; urgency=medium

  * New upstream version 2.5.0
  * debian/rules: Use execute_after_dh_auto_install

 -- Angel Abad <angel@debian.org>  Wed, 19 Aug 2020 16:42:24 +0200

yadm (2.4.0-2) unstable; urgency=medium

  * Update to debhelper compatibility level V13.

 -- Russ Allbery <rra@debian.org>  Tue, 28 Apr 2020 18:56:20 -0700

yadm (2.4.0-1) unstable; urgency=medium

  * Update to new upstream version 2.4.0.
    - Support multiple keys in yadm.gpg-recipient
    - Ensure all templates are written atomically
    - Add encrypt_with_checksums to the hooks collection
    - Escape white space in YADM_HOOK_FULL_COMMAND
    - Improve parsing of os-release
    - Improve identification of WSL
    - Write encrypt-based exclusions during decrypt
  * Install contrib/hooks as usr/share/doc/yadm/examples/hooks.

 -- Russ Allbery <rra@debian.org>  Thu, 27 Feb 2020 20:27:16 -0800

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Angel Abad <angel@debian.org>,
  Russ Allbery <rra@debian.org>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://github.com/TheLocehiliosan/yadm

## yadm 3.0.2

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PYTESTS = $(wildcard test/test_*.py)
-IMAGE = yadm/testbed:2020-07-08
+IMAGE = yadm/testbed:2020-12-29
 
 .PHONY: all
 all:
@@ -23,7 +23,7 @@
 	@echo
 	@echo '  make testhost [version=VERSION]'
 	@echo '    - Create an ephemeral container for doing adhoc yadm testing. The'
-	@echo '      HEAD revision of yadm will be used unless "version" is'
+	@echo '      working copy version of yadm will be used unless "version" is'
 	@echo '      specified. "version" can be set to any commit, branch, tag, etc.'
 	@echo '      The targeted "version" will be retrieved from the repo, and'
 	@echo '      linked into the container as a local volume.'
@@ -33,7 +33,7 @@
 	@echo '      exiting the shell, a log of the commands used to illustrate the'
 	@echo '      problem will be written to the file "script.txt". This file can'
 	@echo '      be useful to developers to make a repeatable test for the'
-	@echo '      problem.'
+	@echo '      problem. The version parameter works as for "testhost" above.'
 	@echo
 	@echo 'LINTING'
 	@echo
@@ -82,7 +82,7 @@
 # Make it possible to run make specifying a py.test test file
 .PHONY: $(PYTESTS)
 $(PYTESTS):
-	@$(MAKE) test testargs="-k $@ $(testargs)"
+	@$(MAKE) test testargs="$@ $(testargs)"
 %.py:
 	@$(MAKE) test testargs="-k $@ $(testargs)"
 
@@ -93,64 +93,74 @@
 		cd /yadm && \
 		py.test -v $(testargs); \
 	else \
-		if command -v "docker-compose" &> /dev/null; then \
-			docker-compose run --rm testbed make test testargs="$(testargs)"; \
-		else \
-			echo "Sorry, this make test requires docker-compose to be installed."; \
-			false; \
-		fi \
+		$(MAKE) -s require-docker && \
+		docker run \
+			--rm -t$(shell test -t 0 && echo i) \
+			-v "$(CURDIR):/yadm:ro" \
+			$(IMAGE) \
+			make test testargs="$(testargs)"; \
 	fi
 
+.PHONY: .testyadm
+.testyadm: version ?= local
+.testyadm:
+	@rm -f $@
+	@if [ "$(version)" = "local" ]; then \
+		ln -sf yadm $@; \
+		echo "Using local yadm ($$(git describe --tags --dirty))"; \
+	else \
+		git show $(version):yadm > $@; \
+		echo "Using yadm version $$(git describe --tags $(version))"; \
+	fi
+	@chmod a+x $@
+
 .PHONY: testhost
-testhost: require-docker
-	@version=HEAD
-	@rm -rf /tmp/testhost
-	@git show $(version):yadm > /tmp/testhost
-	@chmod a+x /tmp/testhost
-	@echo Starting testhost version=\"$$version\"
+testhost: require-docker .testyadm
+	@echo "Starting testhost"
 	@docker run \
 		-w /root \
 		--hostname testhost \
 		--rm -it \
-		-v "/tmp/testhost:/bin/yadm:ro" \
+		-v "$(CURDIR)/.testyadm:/bin/yadm:ro" \
 		$(IMAGE) \
 		bash -l
 
 .PHONY: scripthost
-scripthost: require-docker
-	@version=HEAD
-	@rm -rf /tmp/testhost
-	@git show $(version):yadm > /tmp/testhost
-	@chmod a+x /tmp/testhost
-	@echo Starting scripthost version=\"$$version\" \(recording script\)
+scripthost: require-docker .testyadm
+	@echo "Starting scripthost \(recording script\)"
 	@printf '' > script.gz
 	@docker run \
 		-w /root \
 		--hostname scripthost \
 		--rm -it \
-		-v "$$PWD/script.gz:/script.gz:rw" \
-		-v "/tmp/testhost:/bin/yadm:ro" \
+		-v "$(CURDIR)/script.gz:/script.gz:rw" \
+		-v "$(CURDIR)/.testyadm:/bin/yadm:ro" \
 		$(IMAGE) \
 		bash -c "script /tmp/script -q -c 'bash -l'; gzip < /tmp/script > /script.gz"
 	@echo
-	@echo "Script saved to $$PWD/script.gz"
+	@echo "Script saved to $(CURDIR)/script.gz"
 
 
 .PHONY: testenv
 testenv:
 	@echo 'Creating a local virtual environment in "testenv/"'
 	@echo
+	@rm -rf testenv
 	python3 -m venv --clear testenv
 	testenv/bin/pip3 install --upgrade pip setuptools
-	testenv/bin/pip3 install --upgrade \
-		flake8==3.7.8 \
-		pylint==2.4.1 \
-		pytest==5.1.3 \
-		yamllint==1.17.0 \
-	;
+	testenv/bin/pip3 install --upgrade -r test/requirements.txt;
+	@for v in $$(sed -En -e 's:.*/yadm-([0-9.]+)$$:\1:p' test/Dockerfile); do \
+		git show $$v:yadm > testenv/bin/yadm-$$v; \
+		chmod +x testenv/bin/yadm-$$v; \
+	done
 	@echo
 	@echo 'To activate this test environment type:'
 	@echo '  source testenv/bin/activate'
+
+.PHONY: image
+image:
+	@docker build -f test/Dockerfile . -t "$(IMAGE)"
+
 
 .PHONY: man
 man:
@@ -168,8 +178,9 @@
 	@groff -man -Tascii ./yadm.1 | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md
 
 .PHONY: contrib
+contrib: SHELL = /bin/bash
 contrib:
-	@echo "CONTRIBUTORS\n" > CONTRIBUTORS
+	@echo -e "CONTRIBUTORS\n" > CONTRIBUTORS
 	@IFS=$$'\n'; for author in $$(git shortlog -ns master gh-pages develop dev-pages | cut -f2); do \
 		git log master gh-pages develop dev-pages \
 			--author="$$author" --format=tformat: --numstat | \
@@ -197,7 +208,7 @@
 
 .PHONY: require-docker
 require-docker:
-	@if ! command -v "docker" &> /dev/null; then \
+	@if ! command -v "docker" > /dev/null 2>&1; then \
 		echo "Sorry, this make target requires docker to be installed."; \
 		false; \
 	fi

=== debian/changelog ===
yadm (3.0.2-2) unstable; urgency=medium

  * Add upstream patch to fix bash tab completion.  (Closes: #980754)

 -- Russ Allbery <rra@debian.org>  Sat, 13 Feb 2021 09:01:05 -0800

yadm (3.0.2-1) unstable; urgency=medium

  * New upstream version 3.0.2.
  * debian/watch: Upgrade to version 4.
  * debian/NEWS: Update breaking changes info.
  * debian/salsa-ci.yml: Add salsa ci basic config.
  * debian/gbp.conf: Add gbp configuration file.
  * Update shell completion install files.
  * Declare compliance with Debian Policy 4.5.1.

 -- Angel Abad <angel@debian.org>  Sun, 31 Jan 2021 10:48:31 +0100

=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,10 @@
 
 # Remove some files installed by upstream that are installed by the
 # packaging logic in different ways.
-override_dh_auto_install:
-	dh_auto_install
+execute_after_dh_auto_install:
 	rm debian/yadm/usr/share/doc/yadm/CHANGES
 	rm debian/yadm/usr/share/doc/yadm/LICENSE
+	rm -r debian/yadm/usr/share/doc/yadm/contrib
 
 override_dh_installchangelogs:
 	dh_installchangelogs CHANGES

## yadm 3.1.1

=== test/requirements.txt ===
envtpl
flake8==3.8.4
j2cli
pylint==2.6.0
pytest==6.2.1
yamllint==1.25.0

=== debian/changelog ===
yadm (3.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 29 Aug 2021 07:10:13 +0800

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/TheLocehiliosan/yadm
 Vcs-Browser: https://salsa.debian.org/debian/yadm
 Vcs-Git: https://salsa.debian.org/debian/yadm.git

## yadm 3.2.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PYTESTS = $(wildcard test/test_*.py)
-IMAGE = yadm/testbed:2020-12-29
+IMAGE = yadm/testbed:2022-01-07
 
 .PHONY: all
 all:
@@ -192,9 +192,9 @@
 	@[ -n "$(PREFIX)" ] || { echo "PREFIX is not set"; exit 1; }
 	@{\
 		set -e                                               ;\
-		bin="$(PREFIX)/bin"                                  ;\
-		doc="$(PREFIX)/share/doc/yadm"                       ;\
-		man="$(PREFIX)/share/man/man1"                       ;\
+		bin="$(DESTDIR)$(PREFIX)/bin"                        ;\
+		doc="$(DESTDIR)$(PREFIX)/share/doc/yadm"             ;\
+		man="$(DESTDIR)$(PREFIX)/share/man/man1"             ;\
 		install -d "$$bin" "$$doc" "$$man"                   ;\
 		install -m 0755 yadm "$$bin"                         ;\
 		install -m 0644 yadm.1 "$$man"                       ;\

=== debian/changelog ===
yadm (3.2.1-1) unstable; urgency=medium

  * New upstream version 3.2.1
  * debian/patches/use-bash-shebang: Fix bash term in posix shell.
  * debian/rules: Use DESTDIR instead of only PREFIX.
  * debian/copyright: Update copyright years.
  * Bump Standards-Version to 4.6.0 (no changes).

 -- Angel Abad <angel@debian.org>  Sat, 16 Apr 2022 13:03:53 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/TheLocehiliosan/yadm
 Vcs-Browser: https://salsa.debian.org/debian/yadm
 Vcs-Git: https://salsa.debian.org/debian/yadm.git

## yadm 3.2.2

=== debian/changelog ===
yadm (3.2.2-1) unstable; urgency=medium

  * New upstream version 3.2.2

 -- Angel Abad <angel@debian.org>  Tue, 21 Feb 2023 17:20:59 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/TheLocehiliosan/yadm
 Vcs-Browser: https://salsa.debian.org/debian/yadm
 Vcs-Git: https://salsa.debian.org/debian/yadm.git

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,9 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
 
-export PREFIX = debian/yadm/usr
+export DESTDIR = debian/yadm
+export PREFIX = /usr
+
 
 %:
 	dh $@

## yadm 3.3.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 PYTESTS = $(wildcard test/test_*.py)
-IMAGE = yadm/testbed:2022-01-07
+IMAGE = docker.io/yadm/testbed:2023-07-12
+OCI = docker
 
 .PHONY: all
 all:
@@ -94,7 +95,7 @@
 		py.test -v $(testargs); \
 	else \
 		$(MAKE) -s require-docker && \
-		docker run \
+		$(OCI) run \
 			--rm -t$(shell test -t 0 && echo i) \
 			-v "$(CURDIR):/yadm:ro" \
 			$(IMAGE) \
@@ -117,7 +118,7 @@
 .PHONY: testhost
 testhost: require-docker .testyadm
 	@echo "Starting testhost"
-	@docker run \
+	@$(OCI) run \
 		-w /root \
 		--hostname testhost \
 		--rm -it \
@@ -129,7 +130,7 @@
 scripthost: require-docker .testyadm
 	@echo "Starting scripthost \(recording script\)"
 	@printf '' > script.gz
-	@docker run \
+	@$(OCI) run \
 		-w /root \
 		--hostname scripthost \
 		--rm -it \
@@ -159,7 +160,7 @@
 
 .PHONY: image
 image:
-	@docker build -f test/Dockerfile . -t "$(IMAGE)"
+	@$(OCI) build -f test/Dockerfile . -t "$(IMAGE)"
 
 
 .PHONY: man
@@ -175,7 +176,7 @@
 	@groff -man -Tps ./yadm.1 > yadm.ps
 
 yadm.md: yadm.1
-	@groff -man -Tascii ./yadm.1 | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md
+	@groff -man -Tutf8 -Z ./yadm.1 | grotty -c | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md
 
 .PHONY: contrib
 contrib: SHELL = /bin/bash
@@ -204,11 +205,11 @@
 
 .PHONY: sync-clock
 sync-clock:
-	docker run --rm --privileged alpine hwclock -s
+	$(OCI) run --rm --privileged alpine hwclock -s
 
 .PHONY: require-docker
 require-docker:
-	@if ! command -v "docker" > /dev/null 2>&1; then \
-		echo "Sorry, this make target requires docker to be installed."; \
+	@if ! command -v $(OCI) > /dev/null 2>&1; then \
+		echo "Sorry, this make target requires docker to be installed, to use another docker-compatible engine, like podman, re-run the make command adding OCI=podman"; \
 		false; \
 	fi

=== test/requirements.txt ===
black==23.1.0
envtpl
flake8==6.0.0
isort==5.12.0
j2cli
pylint==2.17.0
pytest==7.2.2
yamllint==1.30.0

=== debian/changelog ===
yadm (3.3.0-1) unstable; urgency=medium

  * New upstream version 3.3.0.
  * d/copyright: Update copyrigh year.
  * d/gbp.conf: Follow DEP-14 to use debian/unstable.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 03 Dec 2024 00:53:26 +0800

## yadm 3.5.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PYTESTS = $(wildcard test/test_*.py)
-IMAGE = docker.io/yadm/testbed:2023-07-12
+IMAGE = docker.io/yadm/testbed:2024-11-11
 OCI = docker
 
 .PHONY: all
@@ -123,6 +123,7 @@
 		--hostname testhost \
 		--rm -it \
 		-v "$(CURDIR)/.testyadm:/bin/yadm:ro" \
+		-v "$(CURDIR)/completion/bash/yadm:/usr/share/bash-completion/completions/yadm:ro" \
 		$(IMAGE) \
 		bash -l
 
@@ -176,7 +177,7 @@
 	@groff -man -Tps ./yadm.1 > yadm.ps
 
 yadm.md: yadm.1
-	@groff -man -Tutf8 -Z ./yadm.1 | grotty -c | col -bx | sed 's/^[A-Z]/## &/g' | sed '/yadm(1)/d' > yadm.md
+	@groff -man -Tutf8 -Z ./yadm.1 | grotty -c | col -bx | sed 's/^[A-Z]/## &/g' | sed '/YADM(1)/d' > yadm.md
 
 .PHONY: contrib
 contrib: SHELL = /bin/bash

=== test/requirements.txt ===
black==24.10.0
envtpl
flake8==7.1.1
isort==5.13.2
j2cli
pylint==3.3.1
pytest==8.3.3
yamllint==1.35.1

=== debian/changelog ===
yadm (3.5.0-1) unstable; urgency=medium

  * New upstream version 3.5.0
  * Declare compliance with Debian Policy 4.7.0.
  * debian/patches/use-bash-shebang: Refresh patch.
  * debian/patches/fix-manpage-typo: New patch fix typo on manpage.
  * debian/copyright: Update copyright years.

 -- Angel Abad <angel@debian.org>  Sun, 16 Mar 2025 12:13:29 +0100

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/yadm-$1\.tar\.gz/ \
  https://github.com/TheLocehiliosan/yadm/tags .*/v?(\d\S+)\.tar\.gz
